//    File:  ArrayExample.java  -  show use of 1-D arrays of int's

import java.io.PrintWriter;

public class ArrayExample {

    // The actual "main routine" -- the class constructor
    ArrayExample() {
        int[] nInts;
        nInts = loadArray();
        displayArray("Initially", nInts);
        System.out.println("Maximum value:  " + max(nInts));
        System.out.println("Average value:  " + average(nInts));
        System.out.printf("Average value: %7.3f\n\n", average(nInts));
        
    }

    // create a array loaded with random int's in range 1..NUM
    int[] loadArray() {
        int[] nArray = new int[(int) ((MAX_SIZE - MIN_SIZE) * Math.random() + MIN_SIZE)];
        for (int i = 0; i < nArray.length; i++)
            nArray[i] = (int) (NUM * Math.random() + 1);
        return nArray;
    }

    // display the array preceded by a title
    void displayArray(String sTitle, int[] nArray) {
        System.out.print(sTitle + "(" + nArray.length + "): ");
        for (int i = 0; i < nArray.length; i++)
            System.out.print(" " + nArray[i]);
        System.out.println();
    }

    // find the maximum of a linear array of int's
    int max(int[] nArray) {
        int nMax = -1;
        if (nArray != null && nArray.length >= 1) {
            nMax = nArray[0];
            for (int i = 1; i < nArray.length; i++)
                if (nArray[i] > nMax)
                    nMax = nArray[i];
        }
        return nMax;
    }

    // find the average of a linear array of int's
    double average(int[] nArray) {
        int nSum = 0;
        for (int i = 0; i < nArray.length; i++)
            nSum += nArray[i];
        return ((double) nSum) / nArray.length;
    }

    // the main routine, the mainline
    public static void main(String[] args) {
        System.out.println("ArrayExample...\n");
        for (int i = 0; i < 5; i++)
            new ArrayExample();
    }

    private static final int MIN_SIZE = 10;        // array of 10
    private static final int MAX_SIZE = 15;        // to 15 entries
    private static final int NUM      = 20;        // max entry size
}

/* ===== output from the program =====

ArrayExample...

Initially(12):  12 18 1 18 15 12 13 1 7 5 7 5
Maximum value:  18
Average value:  9.5
Average value:   9.500

Initially(11):  11 7 8 5 4 4 12 19 13 9 11
Maximum value:  19
Average value:  9.363636363636363
Average value:   9.364

Initially(14):  11 2 1 5 13 16 11 17 7 1 13 6 17 19
Maximum value:  19
Average value:  9.928571428571429
Average value:   9.929

Initially(13):  19 2 7 6 12 15 6 5 9 8 13 4 14
Maximum value:  19
Average value:  9.23076923076923
Average value:   9.231

Initially(11):  14 13 19 13 20 7 14 3 3 8 15
Maximum value:  20
Average value:  11.727272727272727
Average value:  11.727

===== end of output ===== */
